* g++.old-deja/g++.bugs/900520_03.C: Limit error to c++14_down.
[official-gcc.git] / libgo / mksysinfo.sh
blobfe0bb545605c30def3522ad3bdbbf1eafdcd1116
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go from gen-sysinfo.go and errno.i.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This reads the
11 # raw data from gen-sysinfo.go which is generated using the
12 # -fdump-go-spec option.
14 # This currently exposes some names that ideally should not be
15 # exposed, as they match grep patterns. E.g., WCHAR_MIN gets exposed
16 # because it starts with W, like the wait flags.
18 OUT=tmp-sysinfo.go
20 set -e
22 echo 'package syscall' > ${OUT}
23 echo 'import "unsafe"' >> ${OUT}
24 echo 'type _ unsafe.Pointer' >> ${OUT}
26 # Get all the consts and types, skipping ones which could not be
27 # represented in Go and ones which we need to rewrite. We also skip
28 # function declarations, as we don't need them here. All the symbols
29 # will all have a leading underscore.
30 grep -v '^// ' gen-sysinfo.go | \
31 grep -v '^func' | \
32 grep -v '^type _timeval ' | \
33 grep -v '^type _timespec_t ' | \
34 grep -v '^type _timespec ' | \
35 grep -v '^type _timestruc_t ' | \
36 grep -v '^type _epoll_' | \
37 grep -v 'in6_addr' | \
38 grep -v 'sockaddr_in6' | \
39 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
40 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
41 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
42 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
43 >> ${OUT}
45 # On AIX, the _arpcom struct, is filtered by the above grep sequence, as it as
46 # a field of type _in6_addr, but other types depend on _arpcom, so we need to
47 # put it back.
48 grep '^type _arpcom ' gen-sysinfo.go | \
49 sed -e 's/_in6_addr/[16]byte/' >> ${OUT}
51 # The errno constants. These get type Errno.
52 egrep '#define E[A-Z0-9_]+ ' errno.i | \
53 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
55 # The O_xxx flags.
56 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
57 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
58 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
59 echo "const O_ASYNC = 0" >> ${OUT}
61 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
62 echo "const O_CLOEXEC = 0" >> ${OUT}
65 # The os package requires F_DUPFD_CLOEXEC to be defined.
66 if ! grep '^const F_DUPFD_CLOEXEC' ${OUT} >/dev/null 2>&1; then
67 echo "const F_DUPFD_CLOEXEC = 0" >> ${OUT}
70 # AIX 7.1 is a 64 bits value for _FCLOEXEC (referenced by O_CLOEXEC)
71 # which leads to a constant overflow when using O_CLOEXEC in some
72 # go code. Issue wan not present in 6.1 (no O_CLOEXEC) and is no
73 # more present in 7.2 (_FCLOEXEC is a 32 bit value).
74 if test "${GOOS}" = "aix" && `oslevel | grep -q "^7.1"`; then
75 sed -e 's/const __FCLOEXEC = .*/const __FCLOEXEC = 0/' ${OUT} > ${OUT}-2
76 mv ${OUT}-2 ${OUT}
79 # These flags can be lost on i386 GNU/Linux when using
80 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
81 # before we see the definition of F_SETLK64.
82 for flag in F_GETLK F_SETLK F_SETLKW; do
83 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
84 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
85 echo "const ${flag} = ${flag}64" >> ${OUT}
87 done
89 # The Flock_t struct for fcntl.
90 grep '^type _flock ' gen-sysinfo.go | \
91 sed -e 's/type _flock/type Flock_t/' \
92 -e 's/l_type/Type/' \
93 -e 's/l_whence/Whence/' \
94 -e 's/l_start/Start/' \
95 -e 's/l_len/Len/' \
96 -e 's/l_pid/Pid/' \
97 >> ${OUT}
99 # The signal numbers.
100 grep '^const _SIG[^_]' gen-sysinfo.go | \
101 grep -v '^const _SIGEV_' | \
102 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
103 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
104 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
105 echo "const SIGPOLL = SIGIO" >> ${OUT}
108 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
109 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
110 echo "const SIGCLD = SIGCHLD" >> ${OUT}
114 # The syscall numbers. We force the names to upper case.
115 grep '^const _SYS_' gen-sysinfo.go | \
116 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
117 while read sys; do
118 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
119 echo "const $sup = _$sys" >> ${OUT}
120 done
122 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
123 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
124 echo "const SYS_GETDENTS = 0" >> ${OUT}
126 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
127 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
130 # Stat constants.
131 grep '^const _S_' gen-sysinfo.go | \
132 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
134 # Mmap constants.
135 grep '^const _PROT_' gen-sysinfo.go | \
136 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
137 grep '^const _MAP_' gen-sysinfo.go | \
138 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
139 grep '^const _MADV_' gen-sysinfo.go | \
140 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
141 grep '^const _MCL_' gen-sysinfo.go | \
142 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
144 # Process status constants.
145 grep '^const _W' gen-sysinfo.go |
146 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
147 # WSTOPPED was introduced in glibc 2.3.4.
148 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
149 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
150 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
151 else
152 echo 'const WSTOPPED = 2' >> ${OUT}
155 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
156 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
157 echo 'const WALL = ___WALL' >> ${OUT}
160 # Networking constants.
161 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
162 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
163 grep '^const _SOMAXCONN' gen-sysinfo.go |
164 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
165 >> ${OUT}
166 grep '^const _SHUT_' gen-sysinfo.go |
167 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
169 # The net package requires some const definitions.
170 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
171 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
172 echo "const $m = 0" >> ${OUT}
174 done
175 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
176 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
177 echo "const $m = -1" >> ${OUT}
179 done
181 # The syscall package requires AF_LOCAL.
182 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
183 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
184 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
188 # sysconf constants.
189 grep '^const __SC' gen-sysinfo.go |
190 sed -e 's/^\(const \)__\(SC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
192 # pathconf constants.
193 grep '^const __PC' gen-sysinfo.go |
194 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
196 # The PATH_MAX constant.
197 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
198 echo 'const PathMax = _PATH_MAX' >> ${OUT}
201 # epoll constants.
202 grep '^const _EPOLL' gen-sysinfo.go |
203 grep -v EPOLLET |
204 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
205 # Make sure EPOLLET is positive.
206 if grep '^const _EPOLLET = [0-9]' gen-sysinfo.go >/dev/null 2>&1; then
207 grep '^const _EPOLLET ' gen-sysinfo.go |
208 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
209 else
210 echo "const EPOLLET = 0x80000000" >> ${OUT}
212 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
213 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
214 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
216 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
217 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
220 # Prctl constants.
221 grep '^const _PR_' gen-sysinfo.go |
222 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
224 # Ptrace constants.
225 grep '^const _PTRACE' gen-sysinfo.go |
226 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
227 # We need some ptrace options that are not defined in older versions
228 # of glibc.
229 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
230 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
232 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
233 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
235 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
236 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
238 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
239 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
241 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
242 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
244 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
245 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
247 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
248 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
250 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
251 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
253 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
254 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
256 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
257 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
259 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
260 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
262 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
263 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
265 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
266 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
268 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
269 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
271 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
272 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
274 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
275 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
277 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
278 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
281 # A helper function that prints a structure from gen-sysinfo.go with the first
282 # letter of the field names in upper case. $1 is the name of structure. If $2
283 # is not empty, the structure or type is renamed to $2.
284 upcase_fields () {
285 name="$1"
286 def=`grep "^type $name " gen-sysinfo.go`
287 fields=`echo $def | sed -e 's/^[^{]*{\(.*\)}$/\1/'`
288 prefix=`echo $def | sed -e 's/{.*//'`
289 if test "$2" != ""; then
290 prefix=`echo $prefix | sed -e "s/$1/$2/"`
292 if test "$fields" != ""; then
293 nfields=
294 while test -n "$fields"; do
295 field=`echo $fields | sed -e 's/^\([^;]*\);.*$/\1/'`
296 fields=`echo $fields | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
297 # capitalize the next character.
298 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
299 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
300 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
301 field="$f$r"
302 nfields="$nfields $field;"
303 done
304 echo "${prefix} {$nfields }"
308 # The registers returned by PTRACE_GETREGS. This is probably
309 # GNU/Linux specific; it should do no harm if there is no
310 # _user_regs_struct.
311 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
312 if test "$regs" = ""; then
313 # mips*
314 regs=`grep '^type _pt_regs struct' gen-sysinfo.go || true`
316 if test "$regs" != ""; then
317 regs=`echo $regs | sed -e 's/type _pt_regs struct//'`
318 regs=`echo $regs |
319 sed -e 's/type __*user_regs_struct struct //' -e 's/[{}]//g'`
320 regs=`echo $regs | sed -e s'/^ *//'`
321 nregs=
322 while test -n "$regs"; do
323 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
324 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
325 # Capitalize the first character of the field.
326 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
327 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
328 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
329 field="$f$r"
330 field=`echo "$field" | sed \
331 -e 's/__user_psw_struct/PtracePsw/' \
332 -e 's/__user_fpregs_struct/PtraceFpregs/' \
333 -e 's/__user_per_struct/PtracePer/'`
334 nregs="$nregs $field;"
335 done
336 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
339 # Some basic types.
340 echo 'type Size_t _size_t' >> ${OUT}
341 echo "type Ssize_t _ssize_t" >> ${OUT}
342 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
343 echo "type Offset_t _off64_t" >> ${OUT}
344 else
345 echo "type Offset_t _off_t" >> ${OUT}
347 echo "type Mode_t _mode_t" >> ${OUT}
348 echo "type Pid_t _pid_t" >> ${OUT}
349 echo "type Uid_t _uid_t" >> ${OUT}
350 echo "type Gid_t _gid_t" >> ${OUT}
351 echo "type Socklen_t _socklen_t" >> ${OUT}
353 # The C int type.
354 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
355 if test "$sizeof_int" = "4"; then
356 echo "type _C_int int32" >> ${OUT}
357 echo "type _C_uint uint32" >> ${OUT}
358 elif test "$sizeof_int" = "8"; then
359 echo "type _C_int int64" >> ${OUT}
360 echo "type _C_uint uint64" >> ${OUT}
361 else
362 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
363 exit 1
366 # The C long type, needed because that is the type that ptrace returns.
367 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
368 if test "$sizeof_long" = "4"; then
369 echo "type _C_long int32" >> ${OUT}
370 echo "type _C_ulong uint32" >> ${OUT}
371 elif test "$sizeof_long" = "8"; then
372 echo "type _C_long int64" >> ${OUT}
373 echo "type _C_ulong uint64" >> ${OUT}
374 else
375 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
376 exit 1
379 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
380 # double is commented by -fdump-go-spec.
381 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
382 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
384 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
385 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
388 # The time_t type.
389 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
390 echo 'type Time_t _time_t' >> ${OUT}
393 # The time structures need special handling: we need to name the
394 # types, so that we can cast integers to the right types when
395 # assigning to the structures.
396 timeval=`grep '^type _timeval ' gen-sysinfo.go`
397 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
398 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
399 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
400 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
401 echo $timeval | \
402 sed -e 's/type _timeval /type Timeval /' \
403 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
404 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
405 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
406 if test "$timespec" = ""; then
407 # IRIX 6.5 has __timespec instead.
408 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
410 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
411 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
412 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
413 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
414 echo $timespec | \
415 sed -e 's/^type ___timespec /type Timespec /' \
416 -e 's/^type _timespec /type Timespec /' \
417 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
418 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
420 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
421 if test "$timestruc" != ""; then
422 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
423 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
424 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
425 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
426 echo $timestruc | \
427 sed -e 's/^type _timestruc_t /type Timestruc /' \
428 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
429 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
432 # The tms struct.
433 grep '^type _tms ' gen-sysinfo.go | \
434 sed -e 's/type _tms/type Tms/' \
435 -e 's/tms_utime/Utime/' \
436 -e 's/tms_stime/Stime/' \
437 -e 's/tms_cutime/Cutime/' \
438 -e 's/tms_cstime/Cstime/' \
439 >> ${OUT}
441 # The stat type.
442 # Prefer largefile variant if available.
443 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
444 if test "$stat" != ""; then
445 grep '^type _stat64 ' gen-sysinfo.go
446 else
447 grep '^type _stat ' gen-sysinfo.go
448 fi | sed -e 's/type _stat64/type Stat_t/' \
449 -e 's/type _stat/type Stat_t/' \
450 -e 's/st_dev/Dev/' \
451 -e 's/st_ino/Ino/g' \
452 -e 's/st_nlink/Nlink/' \
453 -e 's/st_mode/Mode/' \
454 -e 's/st_uid/Uid/' \
455 -e 's/st_gid/Gid/' \
456 -e 's/st_rdev/Rdev/' \
457 -e 's/st_size/Size/' \
458 -e 's/st_blksize/Blksize/' \
459 -e 's/st_blocks/Blocks/' \
460 -e 's/st_atim/Atim/' \
461 -e 's/st_mtim/Mtim/' \
462 -e 's/st_ctim/Ctim/' \
463 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
464 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
465 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
466 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
467 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
468 >> ${OUT}
470 # The directory searching types.
471 # Prefer largefile variant if available.
472 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
473 if test "$dirent" != ""; then
474 grep '^type _dirent64 ' gen-sysinfo.go
475 else
476 grep '^type _dirent ' gen-sysinfo.go
477 fi | sed -e 's/type _dirent64/type Dirent/' \
478 -e 's/type _dirent/type Dirent/' \
479 -e 's/d_name \[0+1\]/d_name [0+256]/' \
480 -e 's/d_name/Name/' \
481 -e 's/]int8/]byte/' \
482 -e 's/d_ino/Ino/' \
483 -e 's/d_off/Off/' \
484 -e 's/d_reclen/Reclen/' \
485 -e 's/d_type/Type/' \
486 >> ${OUT}
487 echo "type DIR _DIR" >> ${OUT}
489 # Values for d_type field in dirent.
490 grep '^const _DT_' gen-sysinfo.go |
491 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
493 # The rusage struct.
494 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
495 if test "$rusage" != ""; then
496 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
497 rusage=`echo $rusage | sed -e 's/Godump_[0-9][0-9]* struct {\([^}]*\)};/\1/g'`
498 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
499 rusage=`echo $rusage | sed -e 's/^ *//'`
500 nrusage=
501 while test -n "$rusage"; do
502 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
503 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
504 # Drop the leading ru_, capitalize the next character.
505 field=`echo $field | sed -e 's/^ru_//'`
506 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
507 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
508 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
509 # Fix _timeval _timespec, and _timestruc_t.
510 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
511 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
512 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
513 field="$f$r"
514 nrusage="$nrusage $field;"
515 done
516 echo "type Rusage struct {$nrusage }" >> ${OUT}
517 else
518 echo "type Rusage struct {}" >> ${OUT}
521 # The RUSAGE constants.
522 grep '^const _RUSAGE_' gen-sysinfo.go | \
523 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
525 # The utsname struct.
526 grep '^type _utsname ' gen-sysinfo.go | \
527 sed -e 's/_utsname/Utsname/' \
528 -e 's/sysname/Sysname/' \
529 -e 's/nodename/Nodename/' \
530 -e 's/release/Release/' \
531 -e 's/version/Version/' \
532 -e 's/machine/Machine/' \
533 -e 's/domainname/Domainname/' \
534 >> ${OUT}
536 # The iovec struct.
537 iovec=`grep '^type _iovec ' gen-sysinfo.go`
538 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
539 echo "type Iovec_len_t $iovec_len" >> ${OUT}
540 echo $iovec | \
541 sed -e 's/_iovec/Iovec/' \
542 -e 's/iov_base/Base/' \
543 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
544 >> ${OUT}
546 # The msghdr struct.
547 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
548 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
549 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
550 echo $msghdr | \
551 sed -e 's/_msghdr/Msghdr/' \
552 -e 's/msg_name/Name/' \
553 -e 's/msg_namelen/Namelen/' \
554 -e 's/msg_iov/Iov/' \
555 -e 's/msg_iovlen/Iovlen/' \
556 -e 's/_iovec/Iovec/' \
557 -e 's/msg_control/Control/' \
558 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
559 -e 's/msg_flags/Flags/' \
560 >> ${OUT}
562 # The MSG_ flags for Msghdr.
563 grep '^const _MSG_' gen-sysinfo.go | \
564 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
566 # The cmsghdr struct.
567 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
568 if test -n "$cmsghdr"; then
569 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
570 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
571 echo "$cmsghdr" | \
572 sed -e 's/_cmsghdr/Cmsghdr/' \
573 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
574 -e 's/cmsg_level/Level/' \
575 -e 's/cmsg_type/Type/' \
576 -e 's/\[\]/[0]/' \
577 >> ${OUT}
580 # The SCM_ flags for Cmsghdr.
581 grep '^const _SCM_' gen-sysinfo.go | \
582 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
584 # The ucred struct.
585 upcase_fields "_ucred" "Ucred" >> ${OUT} || true
587 # The ip_mreq struct.
588 grep '^type _ip_mreq ' gen-sysinfo.go | \
589 sed -e 's/_ip_mreq/IPMreq/' \
590 -e 's/imr_multiaddr/Multiaddr/' \
591 -e 's/imr_interface/Interface/' \
592 -e 's/_in_addr/[4]byte/g' \
593 >> ${OUT}
595 # We need IPMreq to compile the net package.
596 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
597 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
600 # The ipv6_mreq struct.
601 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
602 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
603 -e 's/ipv6mr_multiaddr/Multiaddr/' \
604 -e 's/ipv6mr_interface/Interface/' \
605 -e 's/_in6_addr/[16]byte/' \
606 >> ${OUT}
608 # We need IPv6Mreq to compile the net package.
609 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
610 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
613 # The ip_mreqn struct.
614 grep '^type _ip_mreqn ' gen-sysinfo.go | \
615 sed -e 's/_ip_mreqn/IPMreqn/' \
616 -e 's/imr_multiaddr/Multiaddr/' \
617 -e 's/imr_address/Address/' \
618 -e 's/imr_ifindex/Ifindex/' \
619 -e 's/_in_addr/[4]byte/g' \
620 >> ${OUT}
622 # We need IPMreq to compile the net package.
623 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
624 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
627 # The icmp6_filter struct.
628 grep '^type _icmp6_filter ' gen-sysinfo.go | \
629 sed -e 's/_icmp6_filter/ICMPv6Filter/' \
630 -e 's/data/Data/' \
631 -e 's/filt/Filt/' \
632 >> ${OUT}
634 # We need ICMPv6Filter to compile the syscall package.
635 if ! grep 'type ICMPv6Filter ' ${OUT} > /dev/null 2>&1; then
636 echo 'type ICMPv6Filter struct { Data [8]uint32 }' >> ${OUT}
639 # The ip6_mtuinfo struct.
640 grep '^type _ip6_mtuinfo ' gen-sysinfo.go | \
641 sed -e 's/_ip6_mtuinfo/IPv6MTUInfo/' \
642 -e 's/ip6m_addr/Addr/' \
643 -e 's/_sockaddr_in6/RawSockaddrInet6/' \
644 -e 's/ip6m_mtu/Mtu/' \
645 >> ${OUT}
647 # Try to guess the type to use for fd_set.
648 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
649 fds_bits_type="_C_long"
650 if test "$fd_set" != ""; then
651 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
653 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
655 # The addrinfo struct.
656 grep '^type _addrinfo ' gen-sysinfo.go | \
657 sed -e 's/_addrinfo/Addrinfo/g' \
658 -e 's/ ai_/ Ai_/g' \
659 >> ${OUT}
661 # The addrinfo and nameinfo flags and errors.
662 grep '^const _AI_' gen-sysinfo.go | \
663 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
664 grep '^const _EAI_' gen-sysinfo.go | \
665 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
666 grep '^const _NI_' gen-sysinfo.go | \
667 sed -e 's/^\(const \)_\(NI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
669 # If nothing else defined EAI_OVERFLOW, make sure it has a value.
670 if ! grep "const EAI_OVERFLOW " ${OUT} >/dev/null 2>&1; then
671 echo "const EAI_OVERFLOW = 0" >> ${OUT}
674 # The passwd struct.
675 grep '^type _passwd ' gen-sysinfo.go | \
676 sed -e 's/_passwd/Passwd/' \
677 -e 's/ pw_/ Pw_/g' \
678 >> ${OUT}
680 # The group struct.
681 grep '^type _group ' gen-sysinfo.go | \
682 sed -e 's/_group/Group/' \
683 -e 's/ gr_/ Gr_/g' \
684 >> ${OUT}
686 # The ioctl flags for the controlling TTY.
687 grep '^const _TIOC' gen-sysinfo.go | \
688 grep -v '_val =' | \
689 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
690 grep '^const _TUNSET' gen-sysinfo.go | \
691 grep -v '_val =' | \
692 sed -e 's/^\(const \)_\(TUNSET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
693 # We need TIOCGWINSZ.
694 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
695 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
696 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
699 if ! grep '^const TIOCSWINSZ' ${OUT} >/dev/null 2>&1; then
700 if grep '^const _TIOCSWINSZ_val' ${OUT} >/dev/null 2>&1; then
701 echo 'const TIOCSWINSZ = _TIOCSWINSZ_val' >> ${OUT}
704 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
705 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
706 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
709 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
710 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
711 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
714 if ! grep '^const TIOCGPGRP' ${OUT} >/dev/null 2>&1; then
715 if grep '^const _TIOCGPGRP_val' ${OUT} >/dev/null 2>&1; then
716 echo 'const TIOCGPGRP = _TIOCGPGRP_val' >> ${OUT}
719 if ! grep '^const TIOCSPGRP' ${OUT} >/dev/null 2>&1; then
720 if grep '^const _TIOCSPGRP_val' ${OUT} >/dev/null 2>&1; then
721 echo 'const TIOCSPGRP = _TIOCSPGRP_val' >> ${OUT}
724 if ! grep '^const TIOCGPTN' ${OUT} >/dev/null 2>&1; then
725 if grep '^const _TIOCGPTN_val' ${OUT} >/dev/null 2>&1; then
726 echo 'const TIOCGPTN = _TIOCGPTN_val' >> ${OUT}
729 if ! grep '^const TIOCSPTLCK' ${OUT} >/dev/null 2>&1; then
730 if grep '^const _TIOCSPTLCK_val' ${OUT} >/dev/null 2>&1; then
731 echo 'const TIOCSPTLCK = _TIOCSPTLCK_val' >> ${OUT}
734 if ! grep '^const TIOCGDEV' ${OUT} >/dev/null 2>&1; then
735 if grep '^const _TIOCGDEV_val' ${OUT} >/dev/null 2>&1; then
736 echo 'const TIOCGDEV = _TIOCGDEV_val' >> ${OUT}
739 if ! grep '^const TIOCSIG' ${OUT} >/dev/null 2>&1; then
740 if grep '^const _TIOCSIG_val' ${OUT} >/dev/null 2>&1; then
741 echo 'const TIOCSIG = _TIOCSIG_val' >> ${OUT}
745 if ! grep '^const TUNSETNOCSUM' ${OUT} >/dev/null 2>&1; then
746 if grep '^const _TUNSETNOCSUM_val' ${OUT} >/dev/null 2>&1; then
747 echo 'const TUNSETNOCSUM = _TUNSETNOCSUM_val' >> ${OUT}
751 if ! grep '^const TUNSETDEBUG' ${OUT} >/dev/null 2>&1; then
752 if grep '^const _TUNSETDEBUG_val' ${OUT} >/dev/null 2>&1; then
753 echo 'const TUNSETDEBUG = _TUNSETDEBUG_val' >> ${OUT}
757 if ! grep '^const TUNSETIFF' ${OUT} >/dev/null 2>&1; then
758 if grep '^const _TUNSETIFF_val' ${OUT} >/dev/null 2>&1; then
759 echo 'const TUNSETIFF = _TUNSETIFF_val' >> ${OUT}
763 if ! grep '^const TUNSETPERSIST' ${OUT} >/dev/null 2>&1; then
764 if grep '^const _TUNSETPERSIST_val' ${OUT} >/dev/null 2>&1; then
765 echo 'const TUNSETPERSIST = _TUNSETPERSIST_val' >> ${OUT}
769 if ! grep '^const TUNSETOWNER' ${OUT} >/dev/null 2>&1; then
770 if grep '^const _TUNSETOWNER_val' ${OUT} >/dev/null 2>&1; then
771 echo 'const TUNSETOWNER = _TUNSETOWNER_val' >> ${OUT}
775 if ! grep '^const TUNSETLINK' ${OUT} >/dev/null 2>&1; then
776 if grep '^const _TUNSETLINK_val' ${OUT} >/dev/null 2>&1; then
777 echo 'const TUNSETLINK = _TUNSETLINK_val' >> ${OUT}
781 if ! grep '^const TUNSETGROUP' ${OUT} >/dev/null 2>&1; then
782 if grep '^const _TUNSETGROUP_val' ${OUT} >/dev/null 2>&1; then
783 echo 'const TUNSETGROUP = _TUNSETGROUP_val' >> ${OUT}
787 if ! grep '^const TUNGETFEATURES' ${OUT} >/dev/null 2>&1; then
788 if grep '^const _TUNGETFEATURES_val' ${OUT} >/dev/null 2>&1; then
789 echo 'const TUNGETFEATURES = _TUNGETFEATURES_val' >> ${OUT}
793 if ! grep '^const TUNSETOFFLOAD' ${OUT} >/dev/null 2>&1; then
794 if grep '^const _TUNSETOFFLOAD_val' ${OUT} >/dev/null 2>&1; then
795 echo 'const TUNSETOFFLOAD = _TUNSETOFFLOAD_val' >> ${OUT}
799 if ! grep '^const TUNSETTXFILTER' ${OUT} >/dev/null 2>&1; then
800 if grep '^const _TUNSETTXFILTER_val' ${OUT} >/dev/null 2>&1; then
801 echo 'const TUNSETTXFILTER = _TUNSETTXFILTER_val' >> ${OUT}
805 if ! grep '^const TUNGETIFF' ${OUT} >/dev/null 2>&1; then
806 if grep '^const _TUNGETIFF_val' ${OUT} >/dev/null 2>&1; then
807 echo 'const TUNGETIFF = _TUNGETIFF_val' >> ${OUT}
811 if ! grep '^const TUNGETSNDBUF' ${OUT} >/dev/null 2>&1; then
812 if grep '^const _TUNGETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
813 echo 'const TUNGETSNDBUF = _TUNGETSNDBUF_val' >> ${OUT}
817 if ! grep '^const TUNSETSNDBUF' ${OUT} >/dev/null 2>&1; then
818 if grep '^const _TUNSETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
819 echo 'const TUNSETSNDBUF = _TUNSETSNDBUF_val' >> ${OUT}
823 if ! grep '^const TUNATTACHFILTER' ${OUT} >/dev/null 2>&1; then
824 if grep '^const _TUNATTACHFILTER_val' ${OUT} >/dev/null 2>&1; then
825 echo 'const TUNATTACHFILTER = _TUNATTACHFILTER_val' >> ${OUT}
829 if ! grep '^const TUNDETACHFILTER' ${OUT} >/dev/null 2>&1; then
830 if grep '^const _TUNDETACHFILTER_val' ${OUT} >/dev/null 2>&1; then
831 echo 'const TUNDETACHFILTER = _TUNDETACHFILTER_val' >> ${OUT}
835 if ! grep '^const TUNGETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
836 if grep '^const _TUNGETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
837 echo 'const TUNGETVNETHDRSZ = _TUNGETVNETHDRSZ_val' >> ${OUT}
841 if ! grep '^const TUNSETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
842 if grep '^const _TUNSETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
843 echo 'const TUNSETVNETHDRSZ = _TUNSETVNETHDRSZ_val' >> ${OUT}
847 if ! grep '^const TUNSETQUEUE' ${OUT} >/dev/null 2>&1; then
848 if grep '^const _TUNSETQUEUE_val' ${OUT} >/dev/null 2>&1; then
849 echo 'const TUNSETQUEUE = _TUNSETQUEUE_val' >> ${OUT}
854 if ! grep '^const TUNSETIFINDEX' ${OUT} >/dev/null 2>&1; then
855 if grep '^const _TUNSETIFINDEX_val' ${OUT} >/dev/null 2>&1; then
856 echo 'const TUNSETIFINDEX = _TUNSETIFINDEX_val' >> ${OUT}
860 if ! grep '^const TUNGETFILTER' ${OUT} >/dev/null 2>&1; then
861 if grep '^const _TUNGETFILTER_val' ${OUT} >/dev/null 2>&1; then
862 echo 'const TUNGETFILTER = _TUNGETFILTER_val' >> ${OUT}
866 # The ioctl flags for terminal control
867 grep '^const _TC[GS]ET' gen-sysinfo.go | grep -v _val | \
868 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
869 if ! grep '^const TCGETS' ${OUT} >/dev/null 2>&1; then
870 if grep '^const _TCGETS_val' ${OUT} >/dev/null 2>&1; then
871 echo 'const TCGETS = _TCGETS_val' >> ${OUT}
874 if ! grep '^const TCSETS' ${OUT} >/dev/null 2>&1; then
875 if grep '^const _TCSETS_val' ${OUT} >/dev/null 2>&1; then
876 echo 'const TCSETS = _TCSETS_val' >> ${OUT}
880 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
881 # needs handling in syscalls.exec.go.
882 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
883 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
884 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
888 # If nothing else defined TIOCSCTTY, make sure it has a value.
889 if ! grep "const TIOCSCTTY " ${OUT} >/dev/null 2>&1; then
890 echo "const TIOCSCTTY = 0" >> ${OUT}
893 # The nlmsghdr struct.
894 grep '^type _nlmsghdr ' gen-sysinfo.go | \
895 sed -e 's/_nlmsghdr/NlMsghdr/' \
896 -e 's/nlmsg_len/Len/' \
897 -e 's/nlmsg_type/Type/' \
898 -e 's/nlmsg_flags/Flags/' \
899 -e 's/nlmsg_seq/Seq/' \
900 -e 's/nlmsg_pid/Pid/' \
901 >> ${OUT}
903 # The nlmsg flags and operators.
904 grep '^const _NLM' gen-sysinfo.go | \
905 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
907 # NLMSG_HDRLEN is defined as an expression using sizeof.
908 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
909 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
910 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
914 # The rtmsg struct.
915 grep '^type _rtmsg ' gen-sysinfo.go | \
916 sed -e 's/_rtmsg/RtMsg/' \
917 -e 's/rtm_family/Family/' \
918 -e 's/rtm_dst_len/Dst_len/' \
919 -e 's/rtm_src_len/Src_len/' \
920 -e 's/rtm_tos/Tos/' \
921 -e 's/rtm_table/Table/' \
922 -e 's/rtm_protocol/Protocol/' \
923 -e 's/rtm_scope/Scope/' \
924 -e 's/rtm_type/Type/' \
925 -e 's/rtm_flags/Flags/' \
926 >> ${OUT}
928 # The rtgenmsg struct.
929 grep '^type _rtgenmsg ' gen-sysinfo.go | \
930 sed -e 's/_rtgenmsg/RtGenmsg/' \
931 -e 's/rtgen_family/Family/' \
932 >> ${OUT}
934 # The routing message flags.
935 grep '^const _RT_' gen-sysinfo.go | \
936 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
937 grep '^const _RTA' gen-sysinfo.go | \
938 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
939 grep '^const _RTF' gen-sysinfo.go | \
940 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
941 grep '^const _RTCF' gen-sysinfo.go | \
942 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
943 grep '^const _RTM' gen-sysinfo.go | \
944 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
945 grep '^const _RTN' gen-sysinfo.go | \
946 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
947 grep '^const _RTPROT' gen-sysinfo.go | \
948 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
950 # The ifinfomsg struct.
951 grep '^type _ifinfomsg ' gen-sysinfo.go | \
952 sed -e 's/_ifinfomsg/IfInfomsg/' \
953 -e 's/ifi_family/Family/' \
954 -e 's/ifi_type/Type/' \
955 -e 's/ifi_index/Index/' \
956 -e 's/ifi_flags/Flags/' \
957 -e 's/ifi_change/Change/' \
958 >> ${OUT}
960 # The interface information types and flags.
961 grep '^const _IFA' gen-sysinfo.go | \
962 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
963 grep '^const _IFLA' gen-sysinfo.go | \
964 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
965 grep '^const _IFF' gen-sysinfo.go | \
966 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
967 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
968 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
969 grep '^const _SIOC' gen-sysinfo.go |
970 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
972 # The ifaddrmsg struct.
973 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
974 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
975 -e 's/ifa_family/Family/' \
976 -e 's/ifa_prefixlen/Prefixlen/' \
977 -e 's/ifa_flags/Flags/' \
978 -e 's/ifa_scope/Scope/' \
979 -e 's/ifa_index/Index/' \
980 >> ${OUT}
982 # The rtattr struct.
983 grep '^type _rtattr ' gen-sysinfo.go | \
984 sed -e 's/_rtattr/RtAttr/' \
985 -e 's/rta_len/Len/' \
986 -e 's/rta_type/Type/' \
987 >> ${OUT}
989 # The in_pktinfo struct.
990 grep '^type _in_pktinfo ' gen-sysinfo.go | \
991 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
992 -e 's/ipi_ifindex/Ifindex/' \
993 -e 's/ipi_spec_dst/Spec_dst/' \
994 -e 's/ipi_addr/Addr/' \
995 -e 's/_in_addr/[4]byte/g' \
996 >> ${OUT}
998 # The in6_pktinfo struct.
999 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
1000 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
1001 -e 's/ipi6_addr/Addr/' \
1002 -e 's/ipi6_ifindex/Ifindex/' \
1003 -e 's/_in6_addr/[16]byte/' \
1004 >> ${OUT}
1006 # The termios struct.
1007 grep '^type _termios ' gen-sysinfo.go | \
1008 sed -e 's/_termios/Termios/' \
1009 -e 's/c_iflag/Iflag/' \
1010 -e 's/c_oflag/Oflag/' \
1011 -e 's/c_cflag/Cflag/' \
1012 -e 's/c_lflag/Lflag/' \
1013 -e 's/c_line/Line/' \
1014 -e 's/c_cc/Cc/' \
1015 -e 's/c_ispeed/Ispeed/' \
1016 -e 's/c_ospeed/Ospeed/' \
1017 >> ${OUT}
1019 # The termios constants.
1020 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
1021 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
1022 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
1023 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
1024 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
1025 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
1026 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
1027 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
1028 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
1029 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
1030 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
1031 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
1033 grep "^const _$n " gen-sysinfo.go | \
1034 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1035 done
1037 # The mount flags
1038 grep '^const _MNT_' gen-sysinfo.go |
1039 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1040 grep '^const _MS_' gen-sysinfo.go |
1041 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1043 # The fallocate flags.
1044 grep '^const _FALLOC_' gen-sysinfo.go |
1045 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1047 # The statfs struct.
1048 # Prefer largefile variant if available.
1049 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
1050 if test "$statfs" != ""; then
1051 grep '^type _statfs64 ' gen-sysinfo.go
1052 else
1053 grep '^type _statfs ' gen-sysinfo.go
1054 fi | sed -e 's/type _statfs64/type Statfs_t/' \
1055 -e 's/type _statfs/type Statfs_t/' \
1056 -e 's/f_type/Type/' \
1057 -e 's/f_bsize/Bsize/' \
1058 -e 's/f_blocks/Blocks/' \
1059 -e 's/f_bfree/Bfree/' \
1060 -e 's/f_bavail/Bavail/' \
1061 -e 's/f_files/Files/' \
1062 -e 's/f_ffree/Ffree/' \
1063 -e 's/f_fsid/Fsid/' \
1064 -e 's/f_namelen/Namelen/' \
1065 -e 's/f_frsize/Frsize/' \
1066 -e 's/f_flags/Flags/' \
1067 -e 's/f_spare/Spare/' \
1068 >> ${OUT}
1070 # The timex struct.
1071 timex=`grep '^type _timex ' gen-sysinfo.go || true`
1072 if test "$timex" = ""; then
1073 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
1074 if test "$timex" != ""; then
1075 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
1078 if test "$timex" != ""; then
1079 echo "$timex" | \
1080 sed -e 's/_timex/Timex/' \
1081 -e 's/modes/Modes/' \
1082 -e 's/offset/Offset/' \
1083 -e 's/freq/Freq/' \
1084 -e 's/maxerror/Maxerror/' \
1085 -e 's/esterror/Esterror/' \
1086 -e 's/status/Status/' \
1087 -e 's/constant/Constant/' \
1088 -e 's/precision/Precision/' \
1089 -e 's/tolerance/Tolerance/' \
1090 -e 's/ time / Time /' \
1091 -e 's/tick/Tick/' \
1092 -e 's/ppsfreq/Ppsfreq/' \
1093 -e 's/jitter/Jitter/' \
1094 -e 's/shift/Shift/' \
1095 -e 's/stabil/Stabil/' \
1096 -e 's/jitcnt/Jitcnt/' \
1097 -e 's/calcnt/Calcnt/' \
1098 -e 's/errcnt/Errcnt/' \
1099 -e 's/stbcnt/Stbcnt/' \
1100 -e 's/tai/Tai/' \
1101 -e 's/_timeval/Timeval/' \
1102 >> ${OUT}
1105 # The rlimit struct.
1106 grep '^type _rlimit ' gen-sysinfo.go | \
1107 sed -e 's/_rlimit/Rlimit/' \
1108 -e 's/rlim_cur/Cur/' \
1109 -e 's/rlim_max/Max/' \
1110 >> ${OUT}
1112 # The RLIMIT constants.
1113 grep '^const _RLIMIT_' gen-sysinfo.go |
1114 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1115 grep '^const _RLIM_' gen-sysinfo.go |
1116 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1118 # The sysinfo struct.
1119 grep '^type _sysinfo ' gen-sysinfo.go | \
1120 sed -e 's/_sysinfo/Sysinfo_t/' \
1121 -e 's/uptime/Uptime/' \
1122 -e 's/loads/Loads/' \
1123 -e 's/totalram/Totalram/' \
1124 -e 's/freeram/Freeram/' \
1125 -e 's/sharedram/Sharedram/' \
1126 -e 's/bufferram/Bufferram/' \
1127 -e 's/totalswap/Totalswap/' \
1128 -e 's/freeswap/Freeswap/' \
1129 -e 's/procs/Procs/' \
1130 -e 's/totalhigh/Totalhigh/' \
1131 -e 's/freehigh/Freehigh/' \
1132 -e 's/mem_unit/Unit/' \
1133 >> ${OUT}
1135 # The ustat struct.
1136 grep '^type _ustat ' gen-sysinfo.go | \
1137 sed -e 's/_ustat/Ustat_t/' \
1138 -e 's/f_tfree/Tfree/' \
1139 -e 's/f_tinode/Tinoe/' \
1140 -e 's/f_fname/Fname/' \
1141 -e 's/f_fpack/Fpack/' \
1142 >> ${OUT}
1143 # Force it to be defined, as on some older GNU/Linux systems the
1144 # header file fails when using with <linux/filter.h>.
1145 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1146 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1149 # The utimbuf struct.
1150 grep '^type _utimbuf ' gen-sysinfo.go | \
1151 sed -e 's/_utimbuf/Utimbuf/' \
1152 -e 's/actime/Actime/' \
1153 -e 's/modtime/Modtime/' \
1154 >> ${OUT}
1156 # The LOCK flags for flock.
1157 grep '^const _LOCK_' gen-sysinfo.go |
1158 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1160 # The PRIO constants.
1161 grep '^const _PRIO_' gen-sysinfo.go | \
1162 sed -e 's/^\(const \)_\(PRIO_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1164 # The GNU/Linux LINUX_REBOOT flags.
1165 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1166 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1168 # The GNU/Linux sock_filter struct.
1169 grep '^type _sock_filter ' gen-sysinfo.go | \
1170 sed -e 's/_sock_filter/SockFilter/' \
1171 -e 's/code/Code/' \
1172 -e 's/jt/Jt/' \
1173 -e 's/jf/Jf/' \
1174 -e 's/k /K /' \
1175 >> ${OUT}
1177 # The GNU/Linux sock_fprog struct.
1178 grep '^type _sock_fprog ' gen-sysinfo.go | \
1179 sed -e 's/_sock_fprog/SockFprog/' \
1180 -e 's/len/Len/' \
1181 -e 's/filter/Filter/' \
1182 -e 's/_sock_filter/SockFilter/' \
1183 >> ${OUT}
1185 # The GNU/Linux filter flags.
1186 grep '^const _BPF_' gen-sysinfo.go | \
1187 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1189 # The GNU/Linux nlattr struct.
1190 grep '^type _nlattr ' gen-sysinfo.go | \
1191 sed -e 's/_nlattr/NlAttr/' \
1192 -e 's/nla_len/Len/' \
1193 -e 's/nla_type/Type/' \
1194 >> ${OUT}
1196 # The GNU/Linux nlmsgerr struct.
1197 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1198 sed -e 's/_nlmsgerr/NlMsgerr/' \
1199 -e 's/error/Error/' \
1200 -e 's/msg/Msg/' \
1201 -e 's/_nlmsghdr/NlMsghdr/' \
1202 >> ${OUT}
1204 # The GNU/Linux rtnexthop struct.
1205 grep '^type _rtnexthop ' gen-sysinfo.go | \
1206 sed -e 's/_rtnexthop/RtNexthop/' \
1207 -e 's/rtnh_len/Len/' \
1208 -e 's/rtnh_flags/Flags/' \
1209 -e 's/rtnh_hops/Hops/' \
1210 -e 's/rtnh_ifindex/Ifindex/' \
1211 >> ${OUT}
1213 # The GNU/Linux netlink flags.
1214 grep '^const _NETLINK_' gen-sysinfo.go | \
1215 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1216 grep '^const _NLA_' gen-sysinfo.go | grep -v '_val =' | \
1217 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1219 if ! grep '^const NLA_HDRLEN' ${OUT} >/dev/null 2>&1; then
1220 if grep '^const _NLA_HDRLEN_val' ${OUT} >/dev/null 2>&1; then
1221 echo 'const NLA_HDRLEN = _NLA_HDRLEN_val' >> ${OUT}
1225 # The GNU/Linux packet socket flags.
1226 grep '^const _PACKET_' gen-sysinfo.go | \
1227 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1229 # The GNU/Linux inotify_event struct.
1230 grep '^type _inotify_event ' gen-sysinfo.go | \
1231 sed -e 's/_inotify_event/InotifyEvent/' \
1232 -e 's/wd/Wd/' \
1233 -e 's/mask/Mask/' \
1234 -e 's/cookie/Cookie/' \
1235 -e 's/len/Len/' \
1236 -e 's/name/Name/' \
1237 -e 's/\[\]/[0]/' \
1238 -e 's/\[0\]byte/[0]int8/' \
1239 >> ${OUT}
1241 # The GNU/Linux CLONE flags.
1242 grep '^const _CLONE_' gen-sysinfo.go | \
1243 sed -e 's/^\(const \)_\(CLONE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1244 # We need some CLONE constants that are not defined in older versions
1245 # of glibc.
1246 if ! grep '^const CLONE_NEWUSER ' ${OUT} > /dev/null 2>&1; then
1247 echo "const CLONE_NEWUSER = 0x10000000" >> ${OUT}
1249 if ! grep '^const CLONE_NEWNET ' ${OUT} > /dev/null 2>&1; then
1250 echo "const CLONE_NEWNET = 0x40000000" >> ${OUT}
1253 # Struct sizes.
1254 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1255 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1256 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1257 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1258 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1259 sock_filter SockFilter sock_fprog SockFprog ucred Ucred \
1260 icmp6_filter ICMPv6Filter ip6_mtuinfo IPv6MTUInfo
1261 while test $# != 0; do
1262 nc=$1
1263 ngo=$2
1264 shift
1265 shift
1266 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1267 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1269 done
1271 # In order to compile the net package, we need some sizes to exist
1272 # even if the types do not.
1273 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1274 echo 'const SizeofIPMreq = 8' >> ${OUT}
1276 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1277 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1279 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1280 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1282 if ! grep 'const SizeofICMPv6Filter ' ${OUT} >/dev/null 2>&1; then
1283 echo 'const SizeofICMPv6Filter = 32' >> ${OUT}
1286 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1287 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1288 sed -e 's/_in6_addr/[16]byte/' \
1289 >> ${OUT}
1291 # The Solaris 12 _flow_arp_desc_t struct.
1292 grep '^type _flow_arp_desc_t ' gen-sysinfo.go | \
1293 sed -e 's/_in6_addr_t/[16]byte/g' \
1294 >> ${OUT}
1296 # The Solaris 12 _flow_l3_desc_t struct.
1297 grep '^type _flow_l3_desc_t ' gen-sysinfo.go | \
1298 sed -e 's/_in6_addr_t/[16]byte/g' \
1299 >> ${OUT}
1301 # The Solaris 12 _mac_ipaddr_t struct.
1302 grep '^type _mac_ipaddr_t ' gen-sysinfo.go | \
1303 sed -e 's/_in6_addr_t/[16]byte/g' \
1304 >> ${OUT}
1306 # The Solaris 12 _mactun_info_t struct.
1307 grep '^type _mactun_info_t ' gen-sysinfo.go | \
1308 sed -e 's/_in6_addr_t/[16]byte/g' \
1309 >> ${OUT}
1311 exit $?